# This version is based on the LWE San Fran verion of freenx that has been
# modified per this link:
#
# http://mail.kde.org/pipermail/freenx-knx/2006-April/003351.html
#
# Source file from here:
# http://studwww.ira.uka.de/~s_franz2/freenx/freenx-0.5.0-test-2006-03-11-7.tar.gz
#
Name:           freenx
Version:        0.5.0
Release:        9%{dist}
#Release:	1.rh.0
Summary:        freenx application/thin-client server

Group:          Applications/Internet
License:        GPL
URL:            http://freenx.berlios.de
Source0:        freenx-%{version}.tar.gz
Patch0:		netcat.diff
Patch1:		nx150backend.diff
Patch2:		nxagent_space_missing.diff
Patch3:		nxnode_2_0_client.patch
BuildArch: 	noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:	openssh-server nc expect xorg-x11 xorg-x11-tools perl
#Requires:       openssh-server nc expect XFree86 XFree86-tools perl
Requires:	nx >= 1.5.0

%description
Freenx is an application/thin-client server based on nx technology. 
NoMachine nx is the next-generation X compression and roundtrip suppression
scheme. It can operate remote X11 sessions over 56k modem dialup links
or anything better. This package contains a free (GPL) implementation
of the nxserver component.

%prep
%setup -q -n freenx-%{version}

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/etc/nxserver
mkdir -p $RPM_BUILD_ROOT/%{_var}/lib/nxserver/db/closed
mkdir -p $RPM_BUILD_ROOT/%{_var}/lib/nxserver/db/running
mkdir -p $RPM_BUILD_ROOT/%{_var}/lib/nxserver/db/failed
chmod 700 $RPM_BUILD_ROOT/%{_var}/lib/nxserver
chmod 700 $RPM_BUILD_ROOT/%{_var}/lib/nxserver/*
chmod 700 $RPM_BUILD_ROOT/%{_var}/lib/nxserver/db/*
install -m 755 nxclient nxnode nxkeygen nxnode-login nxserver nxprint nxsetup\
 nxloadconfig $RPM_BUILD_ROOT/%{_bindir}
install -m 755 node.conf.sample $RPM_BUILD_ROOT/etc/nxserver

%clean
rm -rf $RPM_BUILD_ROOT

%post
export $(grep ^NX_DIR %{_bindir}/nxloadconfig)
export $(grep ^NX_HOME_DIR %{_bindir}/nxloadconfig)
export $(grep ^NX_SESS_DIR %{_bindir}/nxloadconfig)
export $(grep ^NX_ETC_DIR %{_bindir}/nxloadconfig)
export $(grep ^NX_LOGFILE %{_bindir}/nxloadconfig)
export $(grep ^SSH_AUTHORIZED_KEYS %{_bindir}/nxloadconfig)
/sbin/service sshd condrestart
touch ${NX_ETC_DIR}/passwords ${NX_ETC_DIR}/passwords.orig ${NX_LOGFILE}
chmod 600 ${NX_ETC_DIR}/pass* ${NX_LOGFILE}
if [ ! -e ${NX_ETC_DIR}/users.id_dsa ]
then
	%{_bindir}/ssh-keygen -f ${NX_ETC_DIR}/users.id_dsa -t dsa -N "" > /dev/null 2>&1
fi
if [ -e ${NX_HOME_DIR}/.ssh/client.id_dsa.key ] && [ -e ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key ]
then
        mv -f ${NX_HOME_DIR}/.ssh/client.id_dsa.key ${NX_ETC_DIR}/client.id_dsa.key
        mv -f ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key ${NX_ETC_DIR}/server.id_dsa.pub.key
fi
if ! { getent passwd | egrep -q "^nx:"; }
then
        %{_sbindir}/useradd -r -m -d ${NX_HOME_DIR} -s %{_bindir}/nxserver nx
        mkdir -p ${NX_HOME_DIR}/.ssh
        chmod 700 ${NX_HOME_DIR}/.ssh
fi
if [ ! -e ${NX_ETC_DIR}/client.id_dsa.key ] || [ ! -e ${NX_ETC_DIR}/server.id_dsa.pub.key ]
then
	rm -f ${NX_ETC_DIR}/client.id_dsa.key
	rm -f ${NX_ETC_DIR}/server.id_dsa.pub.key
	%{_bindir}/ssh-keygen -q -t dsa -N '' -f ${NX_ETC_DIR}/local.id_dsa
	mv ${NX_ETC_DIR}/local.id_dsa ${NX_ETC_DIR}/client.id_dsa.key
	mv ${NX_ETC_DIR}/local.id_dsa.pub ${NX_ETC_DIR}/server.id_dsa.pub.key
fi
cp -f ${NX_ETC_DIR}/client.id_dsa.key ${NX_HOME_DIR}/.ssh/client.id_dsa.key
cp -f ${NX_ETC_DIR}/server.id_dsa.pub.key ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key
chmod 600 ${NX_ETC_DIR}/client.id_dsa.key ${NX_ETC_DIR}/server.id_dsa.pub.key\
 ${NX_HOME_DIR}/.ssh/client.id_dsa.key ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key
cat ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key > ${NX_HOME_DIR}/.ssh/authorized_keys2
chmod 640 ${NX_HOME_DIR}/.ssh/authorized_keys2
echo -n "127.0.0.1 " > ${NX_HOME_DIR}/.ssh/known_hosts
cat /etc/ssh/ssh_host_rsa_key.pub >> ${NX_HOME_DIR}/.ssh/known_hosts
chown -R nx:root /var/lib/nxserver
chown -R nx:root $NX_SESS_DIR
if [ -e /var/lib/nxserver/running ]
then
	mv /var/lib/nxserver/running/* $NX_SESS_DIR/running
	mv /var/lib/nxserver/closed/* $NX_SESS_DIR/closed
	mv /var/lib/nxserver/failed/* $NX_SESS_DIR/failed
	rm -rf /var/lib/nxserver/running
	rm -rf /var/lib/nxserver/closed
	rm -rf /var/lib/nxserver/failed
	chown -R nx:root $NX_SESS_DIR
fi
chown -R nx:root $NX_ETC_DIR
chown -R nx:root $NX_HOME_DIR
chown nx:root ${NX_LOGFILE}

%preun
if [ $1 = 0 ]
then
	export $(grep ^NX_DIR %{_bindir}/nxloadconfig)
	export $(grep ^NX_HOME_DIR %{_bindir}/nxloadconfig)
	rm %{_var}/lib/nxserver/db/closed/* > /dev/null 2>&1
	rm %{_var}/lib/nxserver/db/running/* > /dev/null 2>&1
	rm %{_var}/lib/nxserver/db/failed/* > /dev/null 2>&1
	mv -f ${NX_HOME_DIR}/.ssh/client.id_dsa.key /etc/nxserver/  > /dev/null 2>&1
	mv -f ${NX_HOME_DIR}/.ssh/server.id_dsa.pub.key /etc/nxserver/  > /dev/null 2>&1
fi

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog CONTRIB
%{_bindir}/*
%dir /etc/nxserver
/etc/nxserver/node.conf.sample
%dir %{_var}/lib/nxserver
%dir %{_var}/lib/nxserver/db
%dir %{_var}/lib/nxserver/db/closed
%dir %{_var}/lib/nxserver/db/running
%dir %{_var}/lib/nxserver/db/failed

%changelog
* Sat Sep  2 2006 Johnny Hughes <johnny@centos.org> 0.5.0-9.c4
- rolled in the patch to allow 2.0.0-98 and above clients (along with 1.5.x
  clients) to be able to connect to freenx.

* Fri Apr 14 2006 Johnny Hughes <johnny@centos.org> 0.5.0-8.c4
- This is an upgraded version of the LWE San Fran. freenx-0.5.0
- that has been upgraded to snapshot 7 and includes a patch
- from the mailing list.
- Source File:
- http://studwww.ira.uka.de/~s_franz2/freenx/freenx-0.5.0-test-2006-03-11-7.tar.gz
- Patch details:
- http://mail.kde.org/pipermail/freenx-knx/2006-April/003351.html 
 
* Thu Aug 11 2005 Johnny Hughes <johnny@centos.org> 0.4.4-1.centos4
- Built for CentOS 4

* Sat Aug 06 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.4-1
- updated to 0.4.4

* Wed Aug 03 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.3.9-2
- updated to 0.4.4-rc1
- added patch to nxloadconfig to require 1.5.0 nx backend

* Mon Aug 01 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.3-1
- updated to 0.4.3

* Tue Jul 26 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.2-1
- updated to 0.4.2

* Tue Jun 28 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.1-1
- updated to 0.4.1
- updated freenx url

* Fri May 06 2005 Rick Stout <zipsonic[AT]gmail.com> 0.4.0-1
- Updated to 0.4.0
- updated netcat.diff for obvious reasons

* Mon Apr 11 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.3.1-4
- spec cleanup

* Tue Mar 22 2005 Rick Stout <zipsonic[AT]gmail.com> - 0:0.3.1
- Updated to 0.3.1 release
* Tue Mar 08 2005 Rick Stout <zipsonic[AT]gmail.com> - 0:0.3.0
- Updated to 0.3.0 release
- Removed home directory patch as it is now default
* Mon Feb 14 2005 Rick Stout <zipsonic[AT]gmail.com> - 0:0.2.8
- Updated to 0.2.8 release
- Fixes some security issues
- Added geom-fix patch for windows client resuming issues
* Thu Dec 02 2004 Rick Stout <zipsonic[AT]gmail.com> - 1:0.2.7
- Fixed package removal not removing the var session directories
* Tue Nov 23 2004 Rick Stout <zipsonic[AT]gmail.com> - 0:0.2.7
- Updated to 0.2.7 release
- fixes some stability issues with 0.2.6
* Fri Nov 12 2004 Rick Stout <zipsonic[AT]gmail.com> - 1:0.2.6
- Fixed a problem with key backup upon removal
* Fri Nov 12 2004 Rick Stout <zipsonic[AT]gmail.com> - 0:0.2.6
- Updated to 0.2.6 release
- Changed setup to have nx user account added as a system account.
- Changed nx home directory to /var/lib/nxserver/nxhome
* Thu Oct 14 2004 Rick Stout <zipsonic[AT]gmail.com> - 0:0.2.5
- updated package to 0.2.5 release
- still applying patch for netcat and useradd
* Fri Oct 08 2004 Rick Stout <zipsonic[AT]gmail.com> - 3:0.2.4
- Added nxsetup functionality to the rpm
- patched nxsetup (fnxncuseradd) script for occasional path error.
- Added patch (fnxncuseradd) to resolve newer client connections (netcat -> nc)
- Changed name to be more friendly (lowercase)
- Added known dependencies
* Thu Sep 30 2004 Rick Stout <zipsonic[AT]gmail.com> - 2:0.2.4
- Patch (fnxpermatch) to fix permissions with key generation
* Wed Sep 29 2004 Rick Stout <zipsonic[AT]gmail.com> - 1:0.2.4
- Initial Fedora RPM release.
- Updated SuSE package for Fedora
